VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DirLNode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'
'A Class used internally by the DirLister Class.
'

Private Const INITIAL_SIZE = 100
Private Const REDIM_INCREMENT = 200

Public Enum DirLNodeStates
    dlnNew = 0
    dlnPathValid
    dlnPathEmpty
End Enum
#If False Then
Dim dlnNew, dlnPathValid, dlnPathEmpty
#End If

Public Parent As DirLNode
Public Path As String
Public State As DirLNodeStates

Private SubNodes() As DirLNode
Private SubNodesUBound As Long
Private SubNodesLastIn As Long
Private SubNodesFirstOut As Long

Public Sub HoldSubDir(ByVal Directory As DirLNode)
    If SubNodesUBound < 0 Then
        SubNodesUBound = INITIAL_SIZE - 1
        ReDim SubNodes(SubNodesUBound)
        SubNodesLastIn = -1
    ElseIf SubNodesLastIn = SubNodesUBound Then
        SubNodesUBound = SubNodesUBound + REDIM_INCREMENT
        ReDim Preserve SubNodes(SubNodesUBound)
    End If
    SubNodesLastIn = SubNodesLastIn + 1
    Set SubNodes(SubNodesLastIn) = Directory
End Sub

Public Function RetrieveNextSubDir() As DirLNode
    Set RetrieveNextSubDir = SubNodes(SubNodesFirstOut)
    Set SubNodes(SubNodesFirstOut) = Nothing
    SubNodesFirstOut = SubNodesFirstOut + 1
    If SubNodesFirstOut > SubNodesLastIn Then
        Erase SubNodes
        SubNodesUBound = -1
        SubNodesFirstOut = 0
        SubNodesLastIn = -1
    End If
End Function

Public Property Get HasSubs() As Boolean
    HasSubs = SubNodesLastIn >= SubNodesFirstOut
End Property

Private Sub Class_Initialize()
    SubNodesUBound = -1
    SubNodesFirstOut = 0
    SubNodesLastIn = -1
End Sub
